/*      file     : TrafficData/TAlgoInfo.C
        project  : PAMINA III
        authors  : Marcus Rickert
        RCS      : $Id: TAlgoInfo.C,v 1.4 2005/03/25 12:28:51 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***INCLUDES************************************************************************ 

#include <TEdge.h>
#include "TAlgoInfo.h"

// ***GLOBAL VARIABLES****************************************************************  

TClassInfo *TAlgoInfo::ClassInfo = 0;

// ***METHODS************************************************************************* 

#ifdef NO_INLINE
#include <TAlgoInfo.i.C>
#endif

// =================================================================================== 
#define ParentClass TParallelListObject
// =================================================================================== 

TAlgoInfo::TAlgoInfo(void)

{
    Node = 0;
    Flags = 0;
    FirstIncidentEdge = INVALID;
    NrOfIncidentEdges = 0;
    Reset();
}

// =================================================================================== 

int
TAlgoInfo::HeapCompare(THeapObject *OtherObject, int) const

{
    TAlgoInfo *OtherInfo = (TAlgoInfo *) OtherObject;

    //    Print("compare %f to %f", Dist, OtherInfo->GetDist());

    if (Dist < OtherInfo->GetDist())
        return 1;
    else
        if (Dist > OtherInfo->GetDist())
            return -1;
    else
        return 0;
}

// =================================================================================== 

TAlgoInfo *
TAlgoInfo::GetInfo(TParallelID ID)

{
    return (TAlgoInfo *) ClassInfo->GetObjectPtr(ID);
}

// =================================================================================== 

bool
TAlgoInfo::Improved(DistType NewDist, TAlgoEdge *NewPred)

{
    if (NewDist < Dist)
    {
        Pred = NewPred;
        Dist = NewDist;
        return TRUE;
    }
    else
        return FALSE;
}

// =================================================================================== 

void
TAlgoInfo::Load(TParallelID theParallelID)

{
    ParallelID = theParallelID;
}

// =================================================================================== 

bool
TAlgoInfo::Load(TNode *theNode)

{
    Node = theNode;
    ParallelID = Node->GetParallelID();
    Location = Node->Loc(TLocationInfo::ClassInfo->GetInfoID());
    return TRUE;
}

// =================================================================================== 

void
TAlgoInfo::Reset(void)

{
    Dist = INVALID_DIST;
    Pred = 0;
}

// =================================================================================== 
#undef ParentClass
