/*      file     : TrafficData/TGridStatLookup.h
        project  : PAMINA III
        author   : Marcus Rickert
        RCS      : $Id: TGridStatLookup.h,v 1.3 2005/03/25 12:28:51 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TGRIDSTATLOOKUP_H
#define TGRIDSTATLOOKUP_H

// ***INCLUDES************************************************************************ 

#include <TTimeLookup.h>
#include <TGridStat.h>

// ***FORWARDS************************************************************************
// ***DEFINES************************************************************************* 
// ***CONSTANTS***********************************************************************
// ***TYPES*************************************************************************** 
// ***CLASSES************************************************************************* 

class TGridStatLookup : public TTimeLookup

{
public:

    TGridStatLookup(TClassInfo *ClassInfo, TParallelID theParallelID);
    
    virtual ~TGridStatLookup(void);

    double
    GetAverageDensity(long TimeStep);

    double
    GetAverageTravelTime(long TimeStep);

    double
    GetAverageVelocity(long TimeStep);

private:

};

// ***EXTERNALS*********************************************************************** 

extern TClassInfo *GridStatLookupClassInfo;
extern TClassInfo *LocalGridStatLookupClassInfo;

// ***PROTOTYPES********************************************************************** 
#ifdef __cplusplus
extern "C" {
#endif

#ifdef __cplusplus
}
#endif
// ***INLINE METHODS******************************************************************
#ifndef NO_INLINE
#endif
// ***TEMPLATE METHODS**************************************************************** 
// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
