/*      file     : TrafficData/TTrafficTimers.h
        project  : PAMINA III
        author   : Marcus Rickert
        RCS      : $Id: TTrafficTimers.h,v 1.3 2005/03/25 12:28:52 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TTRAFFICTIMERS_H
#define TTRAFFICTIMERS_H

// ***INCLUDES************************************************************************ 

#include <TClassInfo.h>

// ***FORWARDS************************************************************************

class TClassInfo;
class TTimeStep;

// ***DEFINES************************************************************************* 

#define DEFAULT_TIMER_SAMPLE_MASK 0x0FL

// ***CONSTANTS***********************************************************************
// ***TYPES*************************************************************************** 
// ***CLASSES************************************************************************* 
// ***EXTERNALS*********************************************************************** 

extern TClassInfo *EdgeTimerClassInfo;
extern TClassInfo *NodeTimerClassInfo;
extern TClassInfo *EdgeTimeStatClassInfo;
extern TClassInfo *NodeTimeStatClassInfo;

extern bool TimeNodes;
extern bool TimeEdges;

// ***PROTOTYPES********************************************************************** 
#ifdef __cplusplus
extern "C" {
#endif
    inline bool
        TimeEdgesNow(const TTimeStep &TimeStep);
    inline bool
        TimeNodesNow(const TTimeStep &TimeStep);
#ifdef __cplusplus
}
#endif
// ***INLINE METHODS******************************************************************
#ifndef NO_INLINE
#  include "TTrafficTimers.i.C"
#endif
// ***TEMPLATE METHODS**************************************************************** 
// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
