/*      file     : TrafficData/TTurnCountStat.h
        project  : PAMINA III
        authors  : Marcus Rickert
        RCS      : $Id: TTurnCountStat.h,v 1.3 2005/03/25 12:28:52 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TTURNCOUNTSTAT_H
#define TTURNCOUNTSTAT_H

// ***INCLUDES************************************************************************ 

#include <TDLList.h>
#include <TStatObject.h>

// ***FORWARDS************************************************************************ 

class TTimeStep;
class TIntersection;
class TStream;

// ***CLASSES************************************************************************* 

class TTurnCountStat : public TStatObject

{
public:

    TTurnCountStat(TParallelID theParallelID = INVALID);
    virtual ~TTurnCountStat(void);

    bool
    Collect(TIntersection *Intersection);

    bool
    Write(TStream *Stream);

    static bool
    WriteStatDescription(TStream *Stream);

    static TClassInfo *ClassInfo;

private:
 
    bool
    Allocate(void);

    virtual bool
    Decode(TBaseStream *aStream, TTransferInfo *TransferInfo);

    virtual bool
    Encode(TBaseStream *aMessage, TTransferInfo *TransferInfo) const;

    virtual void
    Reset(void);

    int          NrOfIncomingEdges;
    int          NrOfOutgoingEdges;
    TParallelID *IncomingEdgeID;
    TParallelID *OutgoingEdgeID;
    long        *TurnCounts;
};

// ===================================================================================

typedef TDLList< TTurnCountStat > TTurnCountStatList;
typedef TDLListEnum< TTurnCountStat > TTurnCountStatEnum;

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
