/*      file     : TrafficData/TrafficDataConfig.h
        project  : PAMINA III
        author   : Marcus Rickert
        RCS      : $Id: TrafficDataConfig.h,v 1.12 2005/03/25 12:28:52 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TRAFFICDATACONFIG_H
#define TRAFFICDATACONFIG_H

// ***DEFINES************************************************************************* 

#define TRAFFIC_GROUP                      "TrafficData"
#define TRAFFIC_NAME_NODEEXTENSION         "NodeExtension"
#define TRAFFIC_NAME_EDGEEXTENSION         "EdgeExtension"
#define TRAFFIC_NAME_ACCESSORYEXTENSION    "AccessoryExtension"
#define TRAFFIC_NAME_PHASEEXTENSION        "PhaseExtension"
#define TRAFFIC_NAME_BASEFILENAME          "BaseFilename"
#define TRAFFIC_NAME_LOADPHASES            "LoadPhases"
#define TRAFFIC_NAME_LOADACCESSORIES       "LoadAccessories"
#define TRAFFIC_NAME_LOADEDGETIMES         "LoadEdgeTimes"
#define TRAFFIC_NAME_SAVEEDGETIMES         "SaveEdgeTimes"
#define TRAFFIC_NAME_LOADNODETIMES         "LoadNodeTimes"
#define TRAFFIC_NAME_SAVENODETIMES         "SaveNodeTimes"
#define TRAFFIC_NAME_GRANULARITY           "Granularity"
#define TRAFFIC_NAME_STARTTIME             "StartTime"
#define TRAFFIC_NAME_EDGETIMESTATINTERVAL  "EdgeTimeStatInterval"
#define TRAFFIC_NAME_EDGETIMEFILENAME      "EdgeTimeFilename"
#define TRAFFIC_NAME_NODETIMESTATINTERVAL  "NodeTimeStatInterval"
#define TRAFFIC_NAME_NODETIMEFILENAME      "NodeTimeFilename"
#define TRAFFIC_NAME_TURNCOUNTSTATINTERVAL "TurnCountStatInterval"

#define TRAFFIC_DEFAULT_STARTTIME        0L

#define SIMULATOR_GROUP                  "Simulator"


#define INTERSECTION_GROUP                      "Intersection"
#define INTERSECTION_NAME_NONGREEN_PHASE_FACTOR "NonGreenPhaseFactor"
#define INTERSECTION_NAME_SCANRANGE             "ScanRange"

#define ROUTER_GROUP                         "Router"
#define ROUTER_NAME_ROUTEPLAN                "Routeplan"
#define ROUTER_NAME_BINARYROUTEPLAN          "BinaryRouteplan"
#define ROUTER_NAME_ROUTEPLANEXTENSION       "RouteplanExtension"
#define ROUTER_NAME_GRIDSTATSAMPLEINTERVAL   "GridStatSampleInterval"
#define ROUTER_NAME_GRIDSTATCOLLECTINTERVAL  "GridStatCollectInterval"
#define ROUTER_NAME_MAXGRIDSTATENTRIES       "MaxGridStatEntries"
#define ROUTER_NAME_TRANSIMSLINKSTAT         "TransimsLinkStat"
#define ROUTER_NAME_QUEUEFEEDBACK            "QueueFeedback"
#define ROUTER_NAME_ROUTINGSTATINTERVAL      "RoutingStatInterval"
#define ROUTER_NAME_ROUTINGSTATFILE          "RoutingStatFile"
#define ROUTER_NAME_ROUTINGSTATDUMP          "RoutingStatDump"
#define ROUTER_NAME_TRAVELTIMEESTIMATEUPDATE "TravelTimeEstimateUpdateInterval"

#define ROUTER_NAME_REROUTINGLOGACTIVE           "ReroutingLog"
#define ROUTER_NAME_REROUTINGFRACTION            "ReroutingFraction"
#define ROUTER_NAME_REROUTINGMINRELDELAY         "ReroutingMinRelativeDelay"
#define ROUTER_NAME_REROUTINGMINRELIMPROVEMENT   "ReroutingMinRelativeImprovement"

#define ROUTER_NAME_COLLECTROUTESBYORIGIN    "CollectRoutesByOrigin"
#define ROUTER_NAME_ROUTEORIGINSECTORS       "RouteOriginSectors"
#define ROUTER_NAME_ROUTEDESTLOWERLEFTX      "RouteDestLowerLeftX"
#define ROUTER_NAME_ROUTEDESTLOWERLEFTY      "RouteDestLowerLeftY"
#define ROUTER_NAME_ROUTEDESTUPPERRIGHTX     "RouteDestUpperRightX"
#define ROUTER_NAME_ROUTEDESTUPPERRIGHTY     "RouteDestUpperRightY"

#define ROUTER_NAME_LOCALGRIDSTATOVERLAP     "LocalGridStatOverlap"

#define SP_GROUP                             "ShortestPath"
#define SP_NAME_SOURCETIMESLACK              "SourceTimeSlack"
#define SP_NAME_MANHATTENLIMIT               "ManhattenLimit"

#define SOURCE_GROUP                         "Source"
#define SOURCE_NAME_INSERTIONGAP             "InsertionGap"
#define SOURCE_NAME_INSERTIONSLACK           "InsertionSlack"

// DEFAULT VALUES

#define TRAFFIC_NODEEXTENSION          "nod"
#define TRAFFIC_EDGEEXTENSION          "edg"
#define TRAFFIC_OUTGOINGEDGEEXTENSION  ".out.idx"
#define TRAFFIC_INCOMINGEDGEEXTENSION  ".in.idx"
#define TRAFFIC_EDGEEXTENSION          "edg"
#define TRAFFIC_EDGETIMEEXTENSION      "edg.time"
#define TRAFFIC_NEWEDGETIMEEXTENSION   "edg.time.new"
#define TRAFFIC_NODETIMEEXTENSION      "nod.time"
#define TRAFFIC_NEWNODETIMEEXTENSION   "nod.time.new"
#define TRAFFIC_ACCESSORYEXTENSION     "acc"
#define TRAFFIC_PHASEEXTENSION         "pha"
#define TRAFFIC_LOADPHASES              0L
#define TRAFFIC_LOADACCESSORIES         0L
#define TRAFFIC_LOADEDGETIMES           0L
#define TRAFFIC_LOADNODETIMES           0L

#define TRAFFIC_DEFAULT_NODETIMESTATINTERVAL    -1L
#define TRAFFIC_DEFAULT_EDGETIMESTATINTERVAL    -1L
#define TRAFFIC_DEFAULT_NODETIMEFILENAME        "%W/node.times"
#define TRAFFIC_DEFAULT_EDGETIMEFILENAME        "%W/edge.times"

#define TRAFFIC_GRANULARITY    150.0  // in meters

#define INTERSECTION_DEFAULT_NONGREEN_PHASE_FACTOR 1.0

#define SOURCE_DEFAULT_INSERTIONGAP   2L
#define SOURCE_DEFAULT_INSERTIONSLACK 5L


// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
