/*      file     : common/TContainerEntry.C
        project  : General Toolbox
        author   : Marcus Rickert
        RCS      : $Id: TContainerEntry.C,v 1.5 2005/03/25 11:04:59 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***INCLUDES************************************************************************ 

#include <stdio.h>

#include "TString.h"

#include "TContainerEntry.h"

// ***METHODS************************************************************************* 

// =================================================================================== 
#define ParentClass TBaseObject
// =================================================================================== 

TContainerEntry::TContainerEntry(const TBaseObject *theDataPtr)

{
    DataPtr = (TBaseObject *) theDataPtr;
}

// =================================================================================== 

TString
TContainerEntry::GetClassName(void) const

{
    return "TContainerEntry";
}

// =================================================================================== 

TString
TContainerEntry::GetInstanceName(void) const

{
    if (DataPtr)
    {
        char Buffer[512];

        sprintf(Buffer, "data (%s:%s)", (char *) DataPtr->GetClassName(),
                (char *) DataPtr->GetInstanceName());
        return Buffer;
    }
    else
        return "empty";
}

// =================================================================================== 

TBaseObject *
TContainerEntry::GetInstancePtr(void)

{
    return DataPtr;
}

// =================================================================================== 
#undef ParentClass
