/*      file     : common/TDList.t.C
        project  : General Toolbox
        author   : Marcus Rickert
        RCS      : $Id: TDLList.t.C,v 1.8 2005/03/25 11:04:59 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#include <gcc_pragma_interface.h>

// ***METHODS************************************************************************* 

/* =================================================================================== */
#define ParentClass TDLListEnumPrimitive
/* =================================================================================== */

template <class T>
TDLListEnum<T>::~TDLListEnum (void)

{
}

/* =================================================================================== */

template <class T>
TDLListEnum<T>::operator T & ()

{
    return (T &) *Current;
}

/* =================================================================================== */

template <class T>
TDLListEnum<T>::operator T * ()

{
    return (T *) Current;
}

/* =================================================================================== */

template <class T>
TDLListEnum<T>::operator const T * () const

{
    return (const T *) Current;
}

/* =================================================================================== */

template <class T>
T *
TDLListEnum<T>::operator -> ()

{
    return (T *) Current;
}

/* =================================================================================== */

template <class T>
void
TDLListEnum<T>::operator = (T *Node)

{
    ParentClass::operator = ((TDLNodePrimitive *) Node);
}

/* =================================================================================== */

template <class T>
void
TDLListEnum<T>::WalksBackwardThrough(const TDLList<T> &aList)

{
    ParentClass::_WalksBackwardThrough((TDLListPrimitive &) aList);
}

/* =================================================================================== */

template <class T>
void
TDLListEnum<T>::WalksBackwardThrough(const TDLList<T> *aList)

{
    ParentClass::_WalksBackwardThrough((TDLListPrimitive &) *aList);
}

/* =================================================================================== */

template <class T>
void
TDLListEnum<T>::WalksForwardThrough(const TDLList<T> &aList)

{
    ParentClass::_WalksForwardThrough((TDLListPrimitive &) aList);
}

/* =================================================================================== */

template <class T>
void
TDLListEnum<T>::WalksForwardThrough(const TDLList<T> *aList)

{
    ParentClass::_WalksForwardThrough((TDLListPrimitive &) *aList);
}

/* =================================================================================== */
#undef ParentClass
#define ParentClass TDLListPrimitive
/* =================================================================================== */

template <class T>
void
TDLList<T>::Absorb(TDLList< T > &aList)

{
    ParentClass::_Absorb((TDLListPrimitive &) aList);
}

/* =================================================================================== */

template <class T>
bool
TDLList<T>::Append(const T *Object, bool Unique)

{
    return ParentClass::_Append((TDLNodePrimitive *)  Object, Unique);
}

/* =================================================================================== */

template <class T>
bool
TDLList<T>::Append(TDLList< T > &aList, bool Unique)

{
    return ParentClass::_Append((TDLListPrimitive &)  aList, Unique);
}

/* =================================================================================== */

template <class T>
bool
TDLList<T>::Delete(const T *Object)

{
    return ParentClass::_Delete((TDLNodePrimitive *) Object);
}

/* =================================================================================== */

template <class T>
TString
TDLList<T>::GetClassName(void) const

{
    return "TDLList<>";
}

/* =================================================================================== */

template <class T>
T *
TDLList<T>::GetFirst(void)

{
    return (T *) GetHead()->GetNext(0);
}

/* =================================================================================== */

template <class T>
T *
TDLList<T>::GetLast(void)

{
    return (T *) GetHead()->GetPrev(0);
}

/* =================================================================================== */

template <class T>
bool
TDLList<T>::IsInList(const T* Element) const

{
    return ParentClass::_IsInList((TDLNodePrimitive *) Element);
}

/* =================================================================================== */

template <class T>
bool
TDLList<T>::Prepend(const T *Object, bool Unique)

{
    return ParentClass::_Prepend((TDLNodePrimitive *) Object, Unique);
}

/* =================================================================================== */
#undef ParentClass
