/*      file     : common/TDataTypeReader.C
        project  : General Toolbox
        author   : Marcus Rickert
        RCS      : $Id: TDataTypeReader.C,v 1.7 2005/03/25 11:04:59 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***INCLUDES************************************************************************ 

#include <TDataTypeReader.h>

// ***METHODS************************************************************************* 

// =================================================================================== 
#define ParentClass TBaseObject
// =================================================================================== 

TDataTypeReader::TDataTypeReader(void)

{
    RandomReads = 0;
    LinearReads = 0;
}

// =================================================================================== 

TDataTypeReader::~TDataTypeReader(void)

{
    if (RandomReads > 0)
        Print("%ld tuples read randomly.", RandomReads);
    if (LinearReads > 0)
        Print("%ld tuples read linearly.", LinearReads);
}

// =================================================================================== 

bool
TDataTypeReader::Eof(void)

{
    return TRUE;
}

// =================================================================================== 

void *
TDataTypeReader::Get(void) const

{
    NotOverloaded("Get()");
    return 0;
}

// =================================================================================== 

void *
TDataTypeReader::Get(LongID)

{
    NotOverloaded("Get(LongID)");
    return 0;
}

// =================================================================================== 

bool
TDataTypeReader::GetLinearIndex(LongID *&, long &)

{
    NotOverloaded("GetLinearIndex");
    return FALSE;
}

// =================================================================================== 

void *
TDataTypeReader::GetSelected(long)

{
    NotOverloaded("GetSelection(long)");
    return 0;
}

// =================================================================================== 

bool
TDataTypeReader::PrepareLinearAccess(void)

{
    return TRUE;
}

// =================================================================================== 

bool
TDataTypeReader::PrepareRandomAccess(void)

{
    return TRUE;
}

// =================================================================================== 

bool
TDataTypeReader::Select(LongID, long &)

{
    NotOverloaded("Select");
    return TRUE;
}

// =================================================================================== 

bool
TDataTypeReader::StartLinearAccess(void)

{
    if (!PrepareLinearAccess())
        return FALSE;
    CurrentEntry = 0;
    return TRUE;
}

// =================================================================================== 

bool
TDataTypeReader::StartRandomAccess(double theRandomFraction)

{
    RandomFraction = theRandomFraction;
    return PrepareRandomAccess();
}

// =================================================================================== 
#undef ParentClass

