/*      file     : common/TIDContainerEntry.C
        project  : General Toolbox
        author   : Marcus Rickert
        RCS      : $Id: TIDContainerEntry.C,v 1.5 2005/03/25 11:04:59 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***INCLUDES************************************************************************ 

#include <stdio.h>

#include <TString.h>

#include "TIDContainerEntry.h"

// ***METHODS************************************************************************* 

// =================================================================================== 
#define ParentClass TContainerEntry
// =================================================================================== 

TIDContainerEntryPrimitive::TIDContainerEntryPrimitive(long theID, 
                                                       const TBaseObject *theDataPtr) :

ParentClass(theDataPtr)

{
    ID = theID;
}

// ===================================================================================

int
TIDContainerEntryPrimitive::Compare(TBaseObject *OtherObject, int) const

{
    TIDContainerEntryPrimitive *OtherEntry = (TIDContainerEntryPrimitive *) OtherObject;

    if (ID > OtherEntry->GetID())
        return 1;
    else
        if (ID < OtherEntry->GetID())
            return -1;
        else
            return 0;
}

// =================================================================================== 

TString
TIDContainerEntryPrimitive::GetInstanceName(void) const

{
    char Buffer[512];
    
    sprintf(Buffer, "(%s) ID:%ld", (char *) ParentClass::GetInstanceName(), ID);
    return Buffer;
}

// =================================================================================== 
#undef ParentClass
