/*      file     : common/TSelector.h
        project  : General Toolbox
        author   : Marcus Rickert
        RCS      : $Id: TSelector.h,v 1.5 2005/03/25 11:05:00 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TSELECTOR_H
#define TSELECTOR_H

// ***INCLUDES************************************************************************ 

#include "TEnumerator.h"

// ***CLASSES************************************************************************* 

/**
  */

class TSelectorPrimitive : public TEnumeratorPrimitive

{
public:

    TSelectorPrimitive(const TContainer *theContainer);
    virtual ~TSelectorPrimitive(void);

    inline long
        operator () (void);

    void
        Enumerate(void);
    inline TBaseObject *
        GetKeyPtr(void);
    inline int
        GetCompareCode(void) const;
    void
        Select(TBaseObject *theKeyPtr = 0, int CompareCode = 0);
    void
        TraceLeft(void);
        
private:

    int          CompareCode;
    TBaseObject *KeyPtr;
};

// ===================================================================================

/**
  */

template < class TContainerEntry, class TData >
class TSelector : public TSelectorPrimitive

{
public:

    TSelector(const TContainer *theContainer);
    virtual ~TSelector();

    operator TData * (void);

    TData *
        operator -> (void);

    void
        Select(TContainerEntry theKey, int CompareCode = 0);

private:

    TContainerEntry Key;
};

// ***INLINE METHODS******************************************************************

#ifndef NO_INLINE
#include "TSelector.i.C"
#endif

// ***TEMPLATE METHODS**************************************************************** 

#if defined (INCLUDE_TEMPLATES) || defined(TEMPLATEBODIES)
#include "TSelector.t.C"
#endif

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
