/*      file     : common/TTimer.h
        project  : General Toolbox
        author   : Marcus Rickert
        RCS      : $Id: TTimer.h,v 1.7 2005/03/25 11:05:00 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TTIMER_H
#define TTIMER_H

/* ***INCLUDES************************************************************************ */

#include <sys/time.h>

#include <Basic.h>

/* ***CLASSES************************************************************************* */

/**
  */

class TTimer

{
 public:
    
    TTimer(TTimer *theParent = 0);
    ~TTimer(void);

    void
    CancelChild(TTimer *theChild);

    double
        GetLap(void);
    double
        GetStoppedTime(void) const;
    double
        GetElapsedTime(void) const;
    void
        Reset(void);

    inline void
         Select(TTimer *NewChild = 0);

    bool
        Start(void);
    bool
        Stop(void);

    inline void
    Unselect(void);

 private:
    
    struct timeval StartTime;
    struct timeval SumTime;
    double LapTime;
    bool   Active;
    
    TTimer *Parent;
    TTimer *CurrentChild;
};

// ***PROTOTYPES********************************************************************** 

#if defined(SUN4) && defined(__GNUC__)
extern "C"
{
    int gettimeofday(struct timeval *, struct timeval *);
}
#endif

// ***INLINE METHODS******************************************************************

#ifndef NO_INLINE
#  include "TTimer.i.C"
#endif

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif

