/*      file     : parallel/TRingTopology.h
        project  : Parallel Topology 2.x
        author   : Marcus Rickert
        RCS      : $Id: TRingTopology.h,v 1.5 2005/03/25 11:06:21 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TRINGTOPOLOGY_H
#define TRINGTOPOLOGY_H

// ***INCLUDES************************************************************************ 

#include <TObjectArray.h>

#include "TTopology.h"

// ***CLASSES************************************************************************* 

/** Topology class representing a simple ring.
  */

class TRingTopology : public TTopology

{
public:

    TRingTopology(const TDLList<TCPNInfo> *theList = 0);
    virtual ~TRingTopology(void);


private:

    bool
        DetermineTopology(void) const;
    virtual TString
        GetClassName(void) const;
    virtual TTopologyType
        GetType(void) const;
};

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
