/*      file     : parallel/TTopologyUser.h
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TTopologyUser.h,v 1.3 2005/03/25 11:06:21 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TTOPOLOGYUSER_H
#define TTOPOLOGYUSER_H

// ***INCLUDES************************************************************************ 

#include <Basic.h>

// ***FORWARDS************************************************************************

class TCPNInfo;

// ***CLASSES*************************************************************************


struct TTopologyUserMutable

{
    bool TopologyCurrent;
};

// ===================================================================================

class TTopologyUser

{
 public:

    TTopologyUser(void);
    virtual ~TTopologyUser(void);

    virtual void
        ActionBeforeAddCPN(const TCPNInfo *);
    virtual void
        ActionAfterAddCPN(const TCPNInfo *);
    virtual void
        ActionBeforeRemoveCPN(const TCPNInfo *);
    virtual void
        ActionAfterRemoveCPN(const TCPNInfo *);
    bool
        IsTopologyCurrent(void) const;
    void
        MarkTopologyCurrent(void) const;
    virtual bool
        MarkTopologyModified(void);

 private:

    TTopologyUserMutable *Mutable;
};

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
