/*      file     : parbalance/ParBalanceConfig.h
        project  : Paralell Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: ParBalanceConfig.h,v 1.8 2005/03/25 11:06:49 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef PARBALANCECONFIG_H
#define PARBALANCECONFIG_H

// ***DEFINES************************************************************************* 

#define BALANCER_GROUP                  "Balancer"
#define BALANCER_NAME_BISECTIONSTAT     "BisectionStat"
#define BALANCER_NAME_SAMPLINGINTERVAL  "SamplingInterval"
#define BALANCER_NAME_PERFHISTORYLENGTH "PerfHistoryLength"
#define BALANCER_NAME_TIMEHISTORYLENGTH "TimeHistoryLength"
#define BALANCER_NAME_TRANSFERDELAY     "TransferDelay"
#define BALANCER_NAME_TRANSFERDELAYVAR  "TransferDelayVariation"
#define BALANCER_NAME_USELOCAL          "UseLocal"
#define BALANCER_NAME_USEPLB            "UsePLB"
#define BALANCER_NAME_TRANSFER          "Transfer"
#define BALANCER_NAME_BLOCK             "Block"
#define BALANCER_NAME_DAMPENING         "Dampening"
#define BALANCER_NAME_TIMEWEIGHT        "TimeWeight"
#define BALANCER_NAME_APPLOADWEIGHT     "AppLoadWeight"
#define BALANCER_NAME_LOADWEIGHT        "LoadWeight"
#define BALANCER_NAME_EXCESSLOADWEIGHT  "ExcessLoadWeight"
#define BALANCER_NAME_LACKOFLOADWEIGHT  "LackOfLoadWeight"
#define BALANCER_NAME_INCIDENCEWEIGHT   "IncidenceWeight"
#define BALANCER_NAME_DISTANCEWEIGHT    "DistanceWeight"
#define BALANCER_NAME_MINPENALTYCHANGE  "MinPenaltyChange"

#define BALANCER_NAME_GLOBALLOADSTATINTERVAL  "GlobalLoadStatInterval"
#define BALANCER_NAME_GLOBALLOADSTATFILENAME  "GlobalLoadStatFilename"
#define BALANCER_NAME_GLOBALLOADSTATDUMP      "GlobalLoadStatDump"

#define BALANCER_DEFAULT_SAMPLINGINTERVAL  5L
#define BALANCER_DEFAULT_PERFHISTORYLENGTH 6L
#define BALANCER_DEFAULT_TIMEHISTORYLENGTH 6L
#define BALANCER_DEFAULT_TRANSFERDELAY     2L
#define BALANCER_DEFAULT_TRANSFERDELAYVAR  5L
#define BALANCER_DEFAULT_BLOCK             0L
#define BALANCER_DEFAULT_DAMPENING         1.0
#define BALANCER_DEFAULT_TIMEWEIGHT        0.0
#define BALANCER_DEFAULT_APPLOADWEIGHT     0.0
#define BALANCER_DEFAULT_LOADWEIGHT        1.0

#define BALANCER_DEFAULT_EXCESSLOADWEIGHT  0.8
#define BALANCER_DEFAULT_LACKOFLOADWEIGHT  0.8
#define BALANCER_DEFAULT_INCIDENCEWEIGHT   0.1
#define BALANCER_DEFAULT_DISTANCEWEIGHT    0.1
#define BALANCER_DEFAULT_MINPENALTYCHANGE  0.01
#define BALANCER_DEFAULT_BISECTIONSTAT     0L

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
