/*      file     : parcontrol/TAppEventHandler.h
        project  : PAMINA III
        author   : Marcus Rickert
        objects  : TEventHandler
        RCS      : $Id: TAppEventHandler.h,v 1.2 2005/03/25 11:07:01 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TAPPEVENTHANDLER_H
#define TAPPEVENTHANDLER_H

// ***INCLUDES************************************************************************ 

#include <TBaseObject.h>

// ***FORWARDS************************************************************************

class TParser;

// ***DEFINES************************************************************************* 
// ***CONSTANTS***********************************************************************
// ***TYPES*************************************************************************** 
// ***CLASSES************************************************************************* 

class TAppEventHandler : public TBaseObject

{
public:

    TAppEventHandler(void);
    virtual ~TAppEventHandler(void);

    bool
    ExecuteTimeStep(const TTimeStep &TimeStep);

    bool
    Open(const char *Filename);

private:

    long     CurrentEventTimeStep;
    TParser *Parser;

    void
    CloseInput(void);

    virtual TString
    GetClassName(void) const;

    bool
    ReadEvent(void);
};

// ***EXTERNALS*********************************************************************** 
// ***PROTOTYPES********************************************************************** 
#ifdef __cplusplus
extern "C" {
#endif

#ifdef __cplusplus
}
#endif
// ***INLINE METHODS******************************************************************
#ifndef NO_INLINE
#endif
// ***TEMPLATE METHODS**************************************************************** 
// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
