/*      file     : partools/TCommunicationLink.h
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TCommunicationLink.h,v 1.3 2005/03/25 11:08:14 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TCOMMUNICATIONLINK_H
#define TCOMMUNICATIONLINK_H

// ***INCLUDES************************************************************************ 

#include <TContainerObject.h>

// ***DEFINES************************************************************************* 

#define CL_FLAG_ACTIVE   0x00000001
#define CL_FLAG_DEFAULT  0

// ***CLASSES************************************************************************* 

class TCommunicationLink : public TContainerObject

{
public:

    TCommunicationLink(TParallelID theParallelID);
    TCommunicationLink(TCPNID theFromCPNID, TCPNID theToCPNID);

    static TClassInfo *ClassInfo;

    inline void
    Activate(void);

    inline void
    Deactivate(void);

    inline TCPNID
    GetFromCPNID(void) const;

    inline TCPNID
    GetToCPNID(void) const;

    virtual TString
    GetInstanceName(void) const;

    inline bool
    IsActive(void) const;

private:

    virtual TString
    GetClassName(void) const;

    void
    _Init(void);

    TCPNID FromCPNID;
    TCPNID ToCPNID;
    long   LinkFlags;
};

// ***TYPES***************************************************************************

typedef TABTree< TIDContainerEntry< TCommunicationLink > > TCommunicationLinkTable;

// ***INLINE METHODS******************************************************************

#ifndef NO_INLINE
#  include "TCommunicationLink.i.C"
#endif

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
