/*      file     : partools/TContainerObject.i.C
        project  : Parallel Toolbox 2.x
        authors  : Marcus Rickert
        RCS      : $Id: TContainerObject.i.C,v 1.7 2005/03/25 11:08:14 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***INCLUDES************************************************************************ 

#include <TClassInfo.h>

// ***METHODS************************************************************************* 

inline void
TContainerObject::AddInstance(TInfoMask aLocalMask)

{
    LocalMask |= aLocalMask;
    NrOfInstances++;
}

// =================================================================================== 

inline TInfoMask
TContainerObject::GetLoadableMask(void) const

{
    return LoadableMask;
}

// =================================================================================== 

inline TInfoMask
TContainerObject::GetLocalMask(void) const

{
    return LocalMask;
}

// =================================================================================== 

inline int
TContainerObject::GetNrOfInstances(void) const

{
    return NrOfInstances;
}

// =================================================================================== 

inline TInfoMask
TContainerObject::GetRequiredMask(void) const

{
    return RequiredMask;
}

// =================================================================================== 

inline void
TContainerObject::SetCPNID(TCPNID theCPNID)

{
    CPNID = theCPNID;
}

// =================================================================================== 

inline void
TContainerObject::SetInfo(TInfoID theInfoID, const TParallelObject *theInfo,
                          bool DeletePrevious)

{
    if (Infos[theInfoID])
        if (DeletePrevious)         
        {
            delete Infos[theInfoID];
            Infos[theInfoID] = 0;
        }
        else
            Warning("SetInfo: previous info for ID %d lost", theInfoID);
    Infos[theInfoID] = (TParallelObject *) theInfo;
}

// =================================================================================== 

inline void
TContainerObject::SetLoadableMask(TInfoMask theMask)

{
    LoadableMask = theMask;
}

// =================================================================================== 

inline void
TContainerObject::SetRequiredMask(TInfoMask theMask)

{
    LoadableMask |= theMask;
    RequiredMask = theMask;
}

// =================================================================================== 
