/*      file     : partools/TDuration.C
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TDuration.C,v 1.2 2005/03/25 11:08:14 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***INCLUDES************************************************************************ 

#include <TBaseStream.h>

#include <TDuration.h>

// ***METHODS************************************************************************* 

#ifdef NO_INLINE
#  include "TDuration.i.C"
#endif

// =================================================================================== 
#define ParentClass TBaseObject
// =================================================================================== 

TDuration::TDuration(void)

{
    
}

// =================================================================================== 

TDuration::TDuration(const TTimeStep &theStart, const TTimeStep &theEnd) :

Start(theStart), End(theEnd)

{
}

// =================================================================================== 

TDuration::TDuration(const TTimeStep &theStart, long Duration) :

Start(theStart), End((long) theStart + Duration)

{
}

// ===================================================================================

bool
TDuration::Decode(TBaseStream *aStream)

{
    return (Start.Decode(aStream) AND
            End.Decode(aStream));
}

// ===================================================================================

bool
TDuration::Encode(TBaseStream *aStream) const

{
    return (Start.Encode(aStream) AND
            End.Encode(aStream));
}

// =================================================================================== 
#undef ParentClass
