/*      file     : partools/TObjectHandler.C
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TObjectHandler.C,v 1.6 2005/03/25 11:08:15 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***INCLUDES************************************************************************ 

#include <TEnvironment.h>

#include <TClassInfo.h>
#include <TParallelObject.h>

#include "TObjectHandler.h"

// ***METHODS************************************************************************* 

TObjectHandler::TObjectHandler(void)

{
}

// =================================================================================== 

bool
TObjectHandler::HandleAction(TParallelObject *, TObjectAction)

{
    Print("TObjectHandler::HandleAction not overloaded");
    return FALSE;
}

// =================================================================================== 

bool
TObjectHandler::HandleAnonymousAction(TClassInfo *, TObjectAction)

{
    Print("TObjectHandler::HandleAnonymousAction not overloaded");
    return FALSE;
}

// =================================================================================== 

bool
TObjectHandler::HandleCreateRequest(TParallelObject *&, const TClassInfo *ClassInfo, 
                                    TParallelID)

{
    Print("TObjectHandler::HandleCreateRequest for '%s' not overloaded",
          (char *) ClassInfo->GetObjectName());
    return TRUE;
}

// =================================================================================== 

bool
TObjectHandler::HandleLoadRequest(TParallelObject *Object, bool &)

{
    Print("TObjectHandler::HandleLoadRequest for '%s' not overloaded",
          (char *) Object->GetObjectName());
    return TRUE;
}

// =================================================================================== 
#undef ParentClass
