/*      file     : partools/TObjectTimer.h
        project  : PAMINA III
        author   : Marcus Rickert
        RCS      : $Id: TObjectTimer.h,v 1.3 2005/03/25 11:08:15 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TOBJECTTIMER_H
#define TOBJECTTIMER_H

// ***INCLUDES************************************************************************ 

#include <TTimer.h>

#include <TStatObject.h>

// ***CLASSES*************************************************************************

class TObjectTimer : public TParallelObject

{
public:

    TObjectTimer(TClassInfo *theClassInfo, TParallelID theParallelID = INVALID);

    double
    GetTime(void);

    inline void
    Start(void);

    inline void
    Stop(double Factor = 1.0);

    void
    Reset(void);

private:

    TTimer Timer;
    double ElapsedTime;
};
 
// ***INLINE METHODS******************************************************************

#ifndef NO_INLINE
#  include "TObjectTimer.i.C"
#endif

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
