/*      file     : pvm/TPVMMessage.h
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TPVMMessage.h,v 1.10 2005/03/25 11:08:26 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TPVMMESSAGE_H
#define TPVMMESSAGE_H

// ***INCLUDES************************************************************************ 

#include <TBaseMessage.h>

// ***DEFINES************************************************************************* 

#define PVM_NOTIFY_DELETE_HOST_MSGTYPE   1
#define PVM_NOTIFY_ADD_HOST_MSGTYPE      2
#define PVM_DEFAULT_MSGTYPE              3

// ***CLASSES************************************************************************* 

class TPVMMessage : public TBaseMessage

{
public:

    TPVMMessage(void);
    virtual ~TPVMMessage(void);
    TPVMMessage(TCommunicationControl *theControl, int theBufferID, TCPNID theSender);
    TPVMMessage(TCommunicationControl *theControl, TMessageID theID, TCPNID theSender, 
                TDestination *theDestination, TMessageTag theTag, 
                TMessageType theType, TMessageFlags theFlags, int theEncoding);

#include "TPVMMessage.Headers.h"

private:

    virtual bool
        BeginSend(void);
    virtual bool
        Deselect(void);
    virtual bool
        EndSend(void);
    TString
        GetClassName(void) const;
    virtual TString
        GetInstanceName(void) const;
    void
        _Init(void);
    bool
        Select(void);

    int   Encoding;
    int   BufferID;
    bool  WasSaved;
};

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
